//---------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <vcl.h>
#include <shellapi.h>
#pragma hdrstop

#include "main.h"
#include "parser.h"
#include "vu.h"
#include "util.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------





extern MicroCode Instr;
extern VU VUchip;

void __fastcall TForm1::FormCreate(TObject *Sender)
{
#include <stdio.h>
#include <string.h>

 LoadInstructions("instructions.txt");
 FileLoad[0]=0;
 MemoLoad[0]=0;
 debugm->Lines->Add("Definitions loaded from instructions.txt");

 memory->Cells[0][0]="Address";
 memory->Cells[1][0]="W";
 memory->Cells[2][0]="Z";
 memory->Cells[3][0]="Y";
 memory->Cells[4][0]="X";

 for(int i=1; i<=1000; i++) {
   memory->Cells[0][i]=i-1;
   code->Cells[1][i]="";
   code->Cells[2][i]=i;
 }
 code->Cells[0][0]="P";
 code->Cells[1][0]="B";
 code->Cells[2][0]="PC";
 code->Cells[3][0]="T";
 code->Cells[4][0]="UPPER";
 code->Cells[5][0]="LOWER";
 FastVF->Cells[0][1]="X";
 FastVF->Cells[0][2]="Y";
 FastVF->Cells[0][3]="Z";
 FastVF->Cells[0][4]="W";
 DrawMemory();
 Status=RESET;
 debugm->Lines->Add("memory initialised");
 debugm->Lines->Add("Status=EMPTY");
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------


//---------------------------------------------------------------------------


//---------------------------------------------------------------------------

void __fastcall TForm1::codeSelectCell(TObject *Sender, int ACol, int ARow,
      bool &CanSelect)
{
 if(ACol<4)
     CanSelect=false;
 else
     CanSelect=true;
 code->Cells[0][code->Row]="";
 code->Cells[0][ARow]=">";
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------


//---------------------------------------------------------------------------

//---------------------------------------------------------------------------

void __fastcall TForm1::codeMouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
 char buffer[100];
  if(Button==1 && code->Cells[5][code->Row]!="") {
      if(code->Cells[1][code->Row]=="") {
         code->Cells[1][code->Row]="O";
         SetBreakPoint(code->Row,1);
         sprintf(buffer,"Set breakpoint in line %d",code->Row);
         debugm->Lines->Add(buffer);
      }
      else {
         code->Cells[1][code->Row]="";
         SetBreakPoint(code->Row,0);
         sprintf(buffer,"Unset breakpoint in line %d",code->Row);
         debugm->Lines->Add(buffer);
      }
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ToolButton1Click(TObject *Sender)
{
char buffer[200];
char error[250];
if (OpenDialog1->Execute()) {
        deb1->Text=OpenDialog1->FileName;
        if(LoadCode(OpenDialog1->FileName.c_str(), error)) {
          savebtn->Enabled=true;
          resetbtn->Enabled=true;
          restartbtn->Enabled=true;
          stepbtn->Enabled=true;
          runbtn->Enabled=true;
          Status=READY;
          DrawProgram();
          strcpy(FileLoad,OpenDialog1->FileName.c_str());
          sprintf(buffer,"Program loaded from %s",FileLoad);
          debugm->Lines->Add(buffer);
          debugm->Lines->Add("Status=READY");
          InstuctionStatus();
        }
        else {
          Application->MessageBox(error, NULL, MB_OKCANCEL);
          Status=RESET;
          sprintf(buffer,"Program load fail from %s",FileLoad);
          debugm->Lines->Add(buffer);
          debugm->Lines->Add("Status=EMPTY");
        }
     }
}

void __fastcall TForm1::DrawParam(VUParam &p, char *a)
{

 switch (p.type) {
   case 1: //VInn
        sprintf(a,"VI%02d", p.index);
        break;
   case 2: //VFnn
        sprintf(a,"VF%02d", p.index);
        break;
   case 3: //VIdest
        sprintf(a,"VI%02d%s", p.index,strlwr(p.sufix));
        break;
   case 4: //VFdest
        sprintf(a,"VF%02d%s", p.index,strlwr(p.sufix));
        break;
   case 5: //ACCdest
        sprintf(a,"ACC%s", strlwr(p.sufix));
        break;
   case 6: //Imm24
        sprintf(a,"0x%06X", p.udata);
        break;
   case 7: //Imm15
        sprintf(a,"%u", p.udata);
        break;
   case 8: //Imm12
        sprintf(a,"%u", p.udata);
        break;
   case 9: //Imm11
        if(p.label[0])
          sprintf(a,"%s",p.label);
        else
          sprintf(a,"%ld", p.data);
        break;
   case 10: //Imm5
        sprintf(a,"%ld", p.data);
        break;
   case 11: //I
        strcpy(a,"I");
        break;
   case 12: //Imm11(VI)
        if(p.label[0])
          sprintf(a,"%s(VI%02d)",p.label,p.index);
        else
          sprintf(a,"0x%04X(VI%02d)",p.data,p.index);
        break;
   case 13: //Imm11(VI)dest
        if(p.label[0])
          sprintf(a,"%s(VI%02d)%s",p.label,p.index,strlwr(p.sufix));
        else
          sprintf(a,"0x%04X(VI%02d)%s",p.data,p.index,strlwr(p.sufix));
        break;
   case 14: //(VI)dest
        sprintf(a,"(VI%02d)%s",p.index,strlwr(p.sufix));
        break;
   case 15: //(--VI)
        sprintf(a,"(--VI%02d)",p.index);
        break;
   case 16: //(VI++)
        sprintf(a,"(VI%02d++)",p.index);
        break;
   case 17: //P
        strcpy(a,"P");
        break;
   case 18: //Q
        strcpy(a,"Q");
        break;
   case 19: //R
        strcpy(a,"R");
        break;
   case 20: //VI01
        strcpy(a,"VI01");
        break;
 }
}

void __fastcall TForm1::DrawProgram()
{
 int i,j,k,m,l=1;
 char scode[100],param[50], auxi[50], aux2[10];
 char *flavors[]={"","i","x","y","z","w","q","A","Ai","Aq","Ax","Ay","Az","Aw"};
 for(int i=1; i<=1000; i++) {
   code->Cells[1][i]="";
   code->Cells[2][i]="";
   code->Cells[3][i]="";
   code->Cells[4][i]="";
   code->Cells[5][i]="";
   code->Cells[6][i]="";
 }
 for (i=0; i<VUchip.NInstructions; i++,l++){
  if(VUchip.program[i].SymbolIndex!=-1) {
    strcpy(scode,VUchip.Labels[VUchip.program[i].SymbolIndex].symb);
    strcat(scode,":");
    code->Cells[4][l++]=scode;
    Application->ProcessMessages();
  }
  VUchip.program[i].addr=i;
  code->Cells[3][l]=VUchip.program[i].tics;
  for(m=UPPER; m<=LOWER; m++) {
    strcpy(auxi,Instr.Instr[VUchip.program[i].InstIndex[m]].nemot);
    if(VUchip.program[i].flg && !m) {
       sprintf(aux2,"[%c]",VUchip.program[i].flg);
       strcat(auxi, aux2);
    }
    k=0;
    while(auxi[k]!='.' && auxi[k]) k++;
    auxi[k]=0;
    //only code exception
    if (!strcmp(auxi,"CLIPW")) strcpy(auxi,"CLIP");
    strcpy(scode,auxi);
    if(VUchip.program [i].flavor[m])
      strcat(scode,flavors[VUchip.program [i].flavor[m]]);
    if(VUchip.program [i].dest[m][0]) {
      strcat(scode,".");
      strcpy(auxi,VUchip.program [i].dest[m]);
      strcat(scode,strlwr(auxi));
    }
    for (j=0; j<Instr.Instr[VUchip.program [i].InstIndex[m]].operands; j++) {
      DrawParam(VUchip.program [i].Params[m][j],param);
      strcat(scode," ");
      strcat(scode,param);
      if(j<Instr.Instr[VUchip.program [i].InstIndex[m]].operands-1)
        strcat(scode,",");
    }
    code->Cells[4+m][l]=scode;
    Application->ProcessMessages();
  }
  code->Cells[2][l]=i;
 }
}

void __fastcall TForm1::SetBreakPoint(int Row, int Mode)
{
 int i,l=0;
// char scode[100],param[50];

 for (i=0; l<Row; i++,l++)
  if(VUchip.program[i].SymbolIndex!=-1)
    l++;

  VUchip.program[i-1].breakpoint=Mode;
}

int __fastcall TForm1::LineInstruction(int a)
{
 int i,l=0;
 for(i=0; i<=a; i++, l++)
  if(VUchip.program[i].SymbolIndex!=-1)
   l++;

 return (l);

}

void __fastcall TForm1::DrawMemory()
{
 int i;
 char val[4][50];
 float stuff;

 for (i=0; i<1000; i++) {
   if(MemInt->Checked) {
     sprintf(val[0],"%ld",VUchip.dataMem[i].w);
     sprintf(val[1],"%ld",VUchip.dataMem[i].z);
     sprintf(val[2],"%ld",VUchip.dataMem[i].y);
     sprintf(val[3],"%ld",VUchip.dataMem[i].x);
   }
   if(MemHex->Checked) {
     sprintf(val[0],"0x%04X",VUchip.dataMem[i].w);
     sprintf(val[1],"0x%04X",VUchip.dataMem[i].z);
     sprintf(val[2],"0x%04X",VUchip.dataMem[i].y);
     sprintf(val[3],"0x%04X",VUchip.dataMem[i].x);
   }
   if(MemFloat->Checked) {
     memcpy(&stuff,&(VUchip.dataMem[i].w),4);
     sprintf(val[0],"%f",stuff);
     memcpy(&stuff,&(VUchip.dataMem[i].z),4);
     sprintf(val[1],"%f",stuff);
     memcpy(&stuff,&(VUchip.dataMem[i].y),4);
     sprintf(val[2],"%f",stuff);
     memcpy(&stuff,&(VUchip.dataMem[i].x),4);
     sprintf(val[3],"%f",stuff);
   }
   memory->Cells[1][i+1]=val[0];
   memory->Cells[2][i+1]=val[1];
   memory->Cells[3][i+1]=val[2];
   memory->Cells[4][i+1]=val[3];
 }
}

//---------------------------------------------------------------------------

void __fastcall TForm1::ToolButton2Click(TObject *Sender)
{
if (OpenDialog1->Execute()) {
        deb1->Text=OpenDialog1->FileName;
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::savebtnClick(TObject *Sender)
{
if ( SaveDialog1->Execute() ) {
        deb1->Text=SaveDialog1->FileName;
     }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::resetbtnClick(TObject *Sender)
{
 int i,j;
 savebtn->Enabled=false;
 resetbtn->Enabled=false;
 restartbtn->Enabled=false;
 stepbtn->Enabled=false;
 runbtn->Enabled=false;
 VUchip.Reset();
 for(i=0; i< Instr.nInstructionDef; i++)
   for(j=0; j<15; j++)
    Instr.Instr[i].lastthr[j]=0;
 DrawMemory();
 DrawProgram();
 RegSeLChange(this);
 Status=RESET;
 debugm->Lines->Add("Status=EMPTY");
}
//---------------------------------------------------------------------------



void __fastcall TForm1::RegSeLChange(TObject *Sender)
{
 int i;

 char itm[20], prval[50];
 VFReg *Reg;
 if(RegSeL->Items->Strings[RegSeL->ItemIndex]=="") {
   rx->Text="";
   ry->Text="";
   rz->Text="";
   rw->Text="";
   rstall->Text="";
   rlastr->Text="";
   rlastw->Text="";
   return;
 }
 strcpy(itm,RegSeL->Items->Strings[RegSeL->ItemIndex].c_str());
 if(itm[1]== 'I') {
   //draw integer register
   i=atoi(itm+2);
   if(vh->Checked)
     sprintf(prval,"0x%02X",(uint16)VUchip.RegInt[i].value());
   else
     sprintf(prval,"%d",VUchip.RegInt[i].value());

   rx->Text=prval;
   ry->Text="";
   rz->Text="";
   rw->Text="";
   rstall->Text=VUchip.RegInt[i].stall();
   rlastr->Text=VUchip.RegInt[i].lastRead();
   rlastw->Text=VUchip.RegInt[i].lastWrite();
 }
 else {
   if(itm[1]==  'F') {
     i=atoi(itm+2);
     Reg=&VUchip.RegFloat[i];
   }
   else {
     switch(itm[0]) {
       case 'A': Reg=&VUchip.ACC; break;
       case 'I': Reg=&VUchip.I; break;
       case 'P': Reg=&VUchip.P; break;
       case 'Q': Reg=&VUchip.Q; break;
       case 'R': Reg=&VUchip.R; break;
     }
   }
   //draw foat register
   if(vflp->Checked) {
      rx->Text=Reg->x();
      ry->Text=Reg->y();
      rz->Text=Reg->z();
      rw->Text=Reg->w();
   }

   if(vfp0->Checked) {
      Reg->mcopy(&i,0);
      sprintf(prval,"%d",i);
      rx->Text=prval;

      Reg->mcopy(&i,1);
      sprintf(prval,"%d",i);
      ry->Text=prval;

      Reg->mcopy(&i,2);
      sprintf(prval,"%d",i);
      rz->Text=prval;

      Reg->mcopy(&i,3);
      sprintf(prval,"%d",i);
      rw->Text=prval;
   }

   if(vfp4->Checked) {
      Reg->mcopy(&i,0);
      sprintf(prval,"%f",(float)i/16.0);
      rx->Text=prval;

      Reg->mcopy(&i,1);
      sprintf(prval,"%f",(float)i/16.0);
      ry->Text=prval;

      Reg->mcopy(&i,2);
      sprintf(prval,"%f",(float)i/16.0);
      rz->Text=prval;

      Reg->mcopy(&i,3);
      sprintf(prval,"%f",(float)i/16.0);
      rw->Text=prval;
   }
   if(vfp12->Checked) {
      Reg->mcopy(&i,0);
      sprintf(prval,"%f",(float)i/4096.0);
      rx->Text=prval;

      Reg->mcopy(&i,1);
      sprintf(prval,"%f",(float)i/4096.0);
      ry->Text=prval;

      Reg->mcopy(&i,2);
      sprintf(prval,"%f",(float)i/4096.0);
      rz->Text=prval;

      Reg->mcopy(&i,3);
      sprintf(prval,"%f",(float)i/4096.0);
      rw->Text=prval;
   }
   if(vfp15->Checked) {
      Reg->mcopy(&i,0);
      sprintf(prval,"%f",(float)i/32768.0);
      rx->Text=prval;

      Reg->mcopy(&i,1);
      sprintf(prval,"%f",(float)i/32768.0);
      ry->Text=prval;

      Reg->mcopy(&i,2);
      sprintf(prval,"%f",(float)i/32768.0);
      rz->Text=prval;

      Reg->mcopy(&i,3);
      sprintf(prval,"%f",(float)i/32768.0);
      rw->Text=prval;
   }
   if(vh->Checked) {
      Reg->mcopy(&i,0);
      sprintf(prval,"0x%04X",(uint32)i);
      rx->Text=prval;

      Reg->mcopy(&i,1);
      sprintf(prval,"0x%04X",(uint32)i);
      ry->Text=prval;

      Reg->mcopy(&i,2);
      sprintf(prval,"0x%04X",(uint32)i);
      rz->Text=prval;

      Reg->mcopy(&i,3);
      sprintf(prval,"0x%04X",(uint32)i);
      rw->Text=prval;
   }

   rstall->Text=Reg->stall();
   if(Reg->lastRead())
     rlastr->Text=Reg->lastRead();
   else
     rlastr->Text=0;
   if(Reg->lastWrite())
     rlastw->Text=Reg->lastWrite();
   else
     rlastw->Text=0;
 }
 RefreshFast();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
 DrawMemory();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::memorySetEditText(TObject *Sender, int ACol,
      int ARow, const AnsiString Value)
{
  float stuff;
  if(MemInt->Checked) {
    switch(ACol) {
      case 1:
            VUchip.dataMem[ARow-1].w=atoi(Value.c_str());
            break;
      case 2:
            VUchip.dataMem[ARow-1].z=atoi(Value.c_str());
            break;
      case 3:
            VUchip.dataMem[ARow-1].y=atoi(Value.c_str());
            break;
      case 4:
            VUchip.dataMem[ARow-1].x=atoi(Value.c_str());
            break;
    }
  }
  if(MemHex->Checked) {
    switch(ACol) {
      case 1:
            VUchip.dataMem[ARow-1].w=htol(Value.c_str());
            break;
      case 2:
            VUchip.dataMem[ARow-1].z=htol(Value.c_str());
            break;
      case 3:
            VUchip.dataMem[ARow-1].y=htol(Value.c_str());
            break;
      case 4:
            VUchip.dataMem[ARow-1].x=htol(Value.c_str());
            break;
    }
  }
  if(MemFloat->Checked) {
    switch(ACol) {
      case 1:
            stuff=atof(Value.c_str());
            memcpy(&(VUchip.dataMem[ARow-1].w),&stuff,4);
            break;
      case 2:
            stuff=atof(Value.c_str());
            memcpy(&(VUchip.dataMem[ARow-1].z),&stuff,4);
            break;
      case 3:
            stuff=atof(Value.c_str());
            memcpy(&(VUchip.dataMem[ARow-1].y),&stuff,4);
            break;
      case 4:
            stuff=atof(Value.c_str());
            memcpy(&(VUchip.dataMem[ARow-1].x),&stuff,4);
            break;
    }

  }
}


//---------------------------------------------------------------------------

void __fastcall TForm1::rwExit(TObject *Sender)
{
 int i;
 char itm[20];
 VFReg *Reg;
 strcpy(itm,RegSeL->Items->Strings[RegSeL->ItemIndex].c_str());
 if(!itm[0] && rw->Text!="") {
     rw->Text="";
     rw->SetFocus();
     return;
 }
 if(!itm[0] && rw->Text=="") {
     return;
 }
 if(itm[1]== 'I') {
   //draw integer register
   if(rw->Text!="") {
     Application->MessageBox("VI Register has only one value", NULL, MB_OKCANCEL);
     rw->Text="";
     rw->SetFocus();
   }
 }
 else {
   if(itm[1]==  'F') {
     i=atoi(itm+2);
     Reg=&VUchip.RegFloat[i];
   }
   else {
     switch(itm[0]) {
       case 'A': Reg=&VUchip.ACC; break;
       case 'I': Reg=&VUchip.I; break;
       case 'P': Reg=&VUchip.P; break;
       case 'Q': Reg=&VUchip.Q; break;
       case 'R': Reg=&VUchip.R; break;
     }
   }
   //draw foat register
   if(vflp->Checked)
     Reg->w(atof(rw->Text.c_str()));
 }
}
//---------------------------------------------------------------------------



void __fastcall TForm1::rxExit(TObject *Sender)
{
 int i;
 char itm[20];
 VFReg *Reg;
 strcpy(itm,RegSeL->Items->Strings[RegSeL->ItemIndex].c_str());
 if(!itm[0] && rx->Text!="") {
     rx->Text="";
     rx->SetFocus();
     return;
 }
 if(!itm[0] && rx->Text=="") {
     return;
 }
 if(itm[1]== 'I') {
   //draw integer register
   i=atoi(itm+2);
   VUchip.RegInt[i].value((int16)atoi(rx->Text.c_str()));
 }
 else {
   if(itm[1]==  'F') {
     i=atoi(itm+2);
     Reg=&VUchip.RegFloat[i];
   }
   else {
     switch(itm[0]) {
       case 'A': Reg=&VUchip.ACC; break;
       case 'I': Reg=&VUchip.I; break;
       case 'P': Reg=&VUchip.P; break;
       case 'Q': Reg=&VUchip.Q; break;
       case 'R': Reg=&VUchip.R; break;
     }
   }
   //draw foat register
   if(vflp->Checked)
     Reg->x(atof(rx->Text.c_str()));
 }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ryExit(TObject *Sender)
{
 int i;
 char itm[20];
 VFReg *Reg;
 strcpy(itm,RegSeL->Items->Strings[RegSeL->ItemIndex].c_str());

 if(!itm[0] && ry->Text!="") {
     ry->Text="";
     ry->SetFocus();
     return;
 }
  if(!itm[0] && ry->Text=="") {
     return;
 }
 if(itm[1]== 'I') {
   //draw integer register
   if(ry->Text!="") {
     Application->MessageBox("VI Register has only one value", NULL, MB_OKCANCEL);
     ry->Text="";
     ry->SetFocus();
   }
 }
 else {
   if(itm[1]==  'F') {
     i=atoi(itm+2);
     Reg=&VUchip.RegFloat[i];
   }
   else {
     switch(itm[0]) {
       case 'A': Reg=&VUchip.ACC; break;
       case 'I': Reg=&VUchip.I; break;
       case 'P': Reg=&VUchip.P; break;
       case 'Q': Reg=&VUchip.Q; break;
       case 'R': Reg=&VUchip.R; break;
     }
   }
   //draw foat register
   if(vflp->Checked)
     Reg->y(atof(ry->Text.c_str()));
 }
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------

void __fastcall TForm1::rzExit(TObject *Sender)
{
 int i;
 char itm[20];
 VFReg *Reg;
 strcpy(itm,RegSeL->Items->Strings[RegSeL->ItemIndex].c_str());
 if(!itm[0] && rz->Text!="") {
     rz->Text="";
     rz->SetFocus();
     return;
 }
 if(!itm[0] && rz->Text=="") {
     return;
 }
 if(itm[1]== 'I') {
   //draw integer register
   if(rz->Text!="") {
     Application->MessageBox("VI Register has only one value", NULL, MB_OKCANCEL);
     rz->Text="";
     rz->SetFocus();
   }
 }
 else {
   if(itm[1]==  'F') {
     i=atoi(itm+2);
     Reg=&VUchip.RegFloat[i];
   }
   else {
     switch(itm[0]) {
       case 'A': Reg=&VUchip.ACC; break;
       case 'I': Reg=&VUchip.I; break;
       case 'P': Reg=&VUchip.P; break;
       case 'Q': Reg=&VUchip.Q; break;
       case 'R': Reg=&VUchip.R; break;
     }
   }
   //draw foat register
   if(vflp->Checked)
     Reg->z(atof(rz->Text.c_str()));
 }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::restartbtnClick(TObject *Sender)
{
 char buffer[200], error[250];
 int i,j;

 if(Status!=READY)
  return;

 savebtn->Enabled=false;
 resetbtn->Enabled=false;
 restartbtn->Enabled=false;
 stepbtn->Enabled=false;
 runbtn->Enabled=false;
 VUchip.Reset();
 DrawMemory();
 DrawProgram();
 RegSeLChange(this);
 if(LoadCode(FileLoad, error)) {
   if(MemoLoad[0]) {
     //LoadMemo()
   }
   savebtn->Enabled=true;
   resetbtn->Enabled=true;
   restartbtn->Enabled=true;
   stepbtn->Enabled=true;
   runbtn->Enabled=true;
   for(i=0; i< Instr.nInstructionDef; i++)
     for(j=0; j<15; j++)
       Instr.Instr[i].lastthr[j]=0;
   Status=READY;
   DrawProgram();
   DrawMemory();
   sprintf(buffer,"Program reloaded from %s",FileLoad);
   debugm->Lines->Add(buffer);
   debugm->Lines->Add("Status=READY");
   InstuctionStatus();
 }
 else{
   Application->MessageBox(error, NULL, MB_OKCANCEL);
   sprintf(buffer,"Program load fail from %s",FileLoad);
   debugm->Lines->Add(buffer);
   debugm->Lines->Add("Status=EMPTY");
   Status=RESET;
 }
 code->Col=3;
 code->Row=1;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::stepbtnClick(TObject *Sender)
{

 int cur;
 cur=VUchip.PC;
 VUchip.CallBack=&DebugTic;
 VUchip.Tic();
 code->Cells[3][LineInstruction(cur)]=VUchip.program[cur].tics;
 code->Col=4;
 code->Row=LineInstruction(VUchip.PC);
 //codeSelectCell(this, 4, LineInstruction(VUchip.PC-1),  dummy);
 DrawMemory(); //refresh memory
 RegSeLChange(this); //refresh registers
 InstuctionStatus();
 ShowFlagsClick(this);
 RefreshFast(); 
}

void TForm1::DebugTic(int mode, int error)
{
 int i;
 char buffer[200], *modedef[]={"UPPER","LOWER"};
 char *succes[]=
 {"success",
  "STALL on param 1!!",
  "STALL on param 2!!",
  "STALL on param 3!!",
  "WARNING P used before fixed (use WAITP)",
  "WARNING Q used before fixed (use WAITQ)",
  "ENTER delay slot...",
  "EXIT delay slot. Instruction Finished!!"};

 if(error==999) {
    Application->MessageBox("End of Program", NULL, MB_OKCANCEL);
    return;
 }
 if(mode==2) {
   i=Form1->LineInstruction(VUchip.PC-1);
   sprintf(buffer,"Instruction line %d [%s][%s] completed",VUchip.PC, Form1->code->Cells[4][i].c_str(),Form1->code->Cells[5][i].c_str());
   Form1->debugm->Lines->Add(buffer);
 }
 else {
   i=Form1->LineInstruction(VUchip.PC);
   sprintf(buffer,"Executing instruction line %d %s [%s]",VUchip.PC, modedef[mode],Form1->code->Cells[4+mode][i].c_str());
   Form1->debugm->Lines->Add(buffer);
   sprintf(buffer,"Result: %s",succes[error]);
   Form1->debugm->Lines->Add(buffer);
 }
 Application->ProcessMessages ();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
 RegSeLChange(this);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ShowFlagsClick(TObject *Sender)
{
 char data[100];
 sprintf (data,"%06ld",iToBin(VUchip.ClipFlag[3]));
 clip3->Text=data;
 sprintf (data,"%06ld",iToBin(VUchip.ClipFlag[2]));
 clip2->Text=data;
 sprintf (data,"%06ld",iToBin(VUchip.ClipFlag[1]));
 clip1->Text=data;
 sprintf (data,"%06ld",iToBin(VUchip.ClipFlag[0]));
 clip0->Text=data;

 sprintf (data,"%04ld",iToBin(VUchip.MacZ));
 MZf->Text=data;
 sprintf (data,"%04ld",iToBin(VUchip.MacS));
 MSf->Text=data;
 sprintf (data,"%04ld",iToBin(VUchip.MacU));
 MUf->Text=data;
 sprintf (data,"%04ld",iToBin(VUchip.MacO));
 MOf->Text=data;

 fz->Text=(VUchip.StatusFlag & 1);
 fs->Text=(VUchip.StatusFlag & 2)/2;
 fu->Text=(VUchip.StatusFlag & 4)/4;
 fo->Text=(VUchip.StatusFlag & 8)/8;
 fi->Text=(VUchip.StatusFlag & 16)/16;
 fd->Text=(VUchip.StatusFlag & 32)/32;
 fzs->Text=(VUchip.StatusFlag & 64)/64;
 fss->Text=(VUchip.StatusFlag & 128)/128;
 fus->Text=(VUchip.StatusFlag & 256)/256;
 fos->Text=(VUchip.StatusFlag & 512)/512;
 fis->Text=(VUchip.StatusFlag & 1024)/1024;
 fds->Text=(VUchip.StatusFlag & 2048)/2048;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::runbtnClick(TObject *Sender)
{
 while(!VUchip.program[VUchip.PC].breakpoint && VUchip.program[VUchip.PC].flg!='E') {
   stepbtnClick(this);
   Application->ProcessMessages ();
 }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ToolButton14Click(TObject *Sender)
{
 int button;
 button = Application->MessageBox("Are you sure?", "Exit", MB_OKCANCEL +
    MB_DEFBUTTON1);
 if (button == IDOK)
   Application->Terminate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::InstuctionStatus()
{
 char data[100];
 int i,j;
 if(Status!=READY)
  return;

 i=LineInstruction(VUchip.PC);
 InstrStatus->Lines->Clear();
 InstrStatus->Lines->Add("------------------------");
 InstrStatus->Lines->Add("    Instrucion UPPER    ");
 InstrStatus->Lines->Add("------------------------");
 sprintf(data," [%s] ",code->Cells[4][i].c_str());
 InstrStatus->Lines->Add(data);
 InstrStatus->Lines->Add("Can be executed...");
 j=Instr.Instr[VUchip.program[VUchip.PC].InstIndex[0]].lastthr[VUchip.program[VUchip.PC].flavor[0]];
 if(j>1)
   sprintf(data,"After %d cycles",j-1);
 else
   sprintf(data,"Inmediatly");
 InstrStatus->Lines->Add(data);
 InstrStatus->Lines->Add("");
InstrStatus->Lines->Add("------------------------");
 InstrStatus->Lines->Add("    Instrucion LOWER    ");
 InstrStatus->Lines->Add("------------------------");
 sprintf(data," [%s] ",code->Cells[5][i].c_str());
 InstrStatus->Lines->Add(data);
 InstrStatus->Lines->Add("Can be executed...");
 j=Instr.Instr[VUchip.program[VUchip.PC].InstIndex[1]].lastthr[VUchip.program[VUchip.PC].flavor[1]];
 if(j>1)
   sprintf(data,"After %d cycles",j-1);
 else
   sprintf(data,"Inmediatly");
 InstrStatus->Lines->Add(data);
 InstrStatus->Lines->Add("");
 InstrStatus->Lines->Add("NOTE: Information is regarding instruction throughput.");
 InstrStatus->Lines->Add("Other issues such Register STALL may occur.");

}


void __fastcall TForm1::ToolButton12Click(TObject *Sender)
{

 ShellExecute(NULL, NULL, "doc/index.htm", NULL, NULL, SW_SHOWNORMAL);
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------

void __fastcall TForm1::RefreshFast()
{
 int i,j;
 char prval[20], praux[20];
 for(i=1; i<16; i++) {
   sprintf(prval,"0x%02X",(uint16)VUchip.RegInt[i].value());
   sprintf(praux,"VI%02d",i);
   FastVI->Cells[i][0]=praux;
   FastVI->Cells[i][1]=prval;
 }
 for(i=1; i<32; i++) {
   sprintf(praux,"VF%02d",i);
   FastVF->Cells[i][0]=praux;
   VUchip.RegFloat[i].mcopy(&j,0);
   sprintf(prval,"0x%04X",(uint32)j);
   FastVF->Cells[i][1]=prval;

   VUchip.RegFloat[i].mcopy(&j,1);
   sprintf(prval,"0x%04X",(uint32)j);
   FastVF->Cells[i][2]=prval;

   VUchip.RegFloat[i].mcopy(&j,2);
   sprintf(prval,"0x%04X",(uint32)j);
   FastVF->Cells[i][3]=prval;

   VUchip.RegFloat[i].mcopy(&j,3);
   sprintf(prval,"0x%04X",(uint32)j);
   FastVF->Cells[i][4]=prval;
 }
}
//---------------------------------------------------------------------------

