#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "util.h"
#include "vu.h"

extern MicroCode Instr;

extern VU VUchip;

int counter=0;

int LoadInstructions (char *file)
{
 /*in a future version this should use
   XML to load data, but by the moment...
   File format is very simple, each instructions has:
   tipe //0 - Micromode Upper
        //1 - Micromode Lower
        //No macromode sorry
   Nemot //String representing instruction
   Suffix //0-No flavors
          //1-3 flavor i.e MAX, MAXi, MAXbc
          //2-8 flavor i.e ADD, ADDi, ADDq, ADDbc, ...
   Dest   //0
   N Operands //Number of operands
   Type 1  //Type of operand,
   Type 2  // 0- VIReg 1- VFReg 2-Integer 3-Float 4-P 5-Q 6-ACC
   ...
   Type n
   Throughput
   Latency
   # at begining means line is comentary
   */
 FILE *In;
 char Line[250];
 int part=0, ope=0,i;

 Instr.nInstructionDef=0;
 if((In=fopen(file,"r"))==NULL)
   return 0;
 while(fgets(Line,250,In)) {
   strtrim(Line);
   if(Line[0]=='#')
        continue;
   switch(part) {
        case 0:
          Instr.Instr[Instr.nInstructionDef].mode =atoi(Line);
          part=1;
          break;
        case 1:
          strcpy(Instr.Instr[Instr.nInstructionDef].nemot,strupr(Line));
          part=2;
          break;
        case 2:
          Instr.Instr[Instr.nInstructionDef].sufix =atoi(Line);
          part=3;
          break;
        case 3:
          Instr.Instr[Instr.nInstructionDef].operands =atoi(Line);
          if(Instr.Instr[Instr.nInstructionDef].operands==0) {
             part=5;
             ope=0;
          }
          else {
             part=4;
             ope=0;
          }
          break;
        case 4:
          strcpy(Instr.Instr[Instr.nInstructionDef].types[ope++],Line);
          if(ope==Instr.Instr[Instr.nInstructionDef].operands) {
             part=5;
             ope=0;
          }
          break;
        case 5:
          Instr.Instr[Instr.nInstructionDef].throughput=atoi(Line);
          part=6;
          break;
        case 6:
          Instr.Instr[Instr.nInstructionDef].latency=atoi(Line);
          part=0;
          for(i=0; i<15; i++)
            Instr.Instr[Instr.nInstructionDef].lastthr[i]=0;
          Instr.nInstructionDef++;
          break;
   }
 }
 if (part!=0)
   return 0;
 return 1;
}


int IsValidInstruction(char *token, int Mode, int *InstIndex, int *flavor, char *dest, char *flg)
{
 //Mode 0-upper 1-lower
 //flavors
 //0 - normal
 //1 - i register
 //2-5 - bc broadcast 2-x 3-y 4-z 5-w
 //6 - q register
 //7 - a acumulator
 //8 - ai acumulator and i register
 //9 - aq acumulator and q register
 //10-13 - abc acumulator broadcast 10-x 11-y 12-z 13-w
 //
 //dest
 //x y z w and combinations

 int i,j,k;
 char root[15],root2[20],defdes[20],teststr[6];

 *flg=0;
 i=0;
 dest[0]=0;
 strcpy(teststr,"XYZW");
 while(token[i]) //take the .dest part
   if(token[i]=='.') {
     token[i]=0;
     strcpy(dest,token+i+1);
   }
   else i++;
 i=0;

 while(token[i]!='[' && token[i]) i++;
   if(token[i]) {
     *flg=token[i+1];
     token[i]=0;
   }

 i=0;
 if(dest[0]) { //check .dest is valid
     for(j=0;j<4;j++)
       for(k=0;k<(int)strlen(dest);k++)
         if(dest[k]==teststr[j]) {
           i++;
           teststr[j]=0;
         }

 }
 if(i!=(int)strlen(dest))
  return 0;
 for (i=0; i<Instr.nInstructionDef; i++)
  if(Instr.Instr[i].mode==Mode) {
     defdes[0]=0;
     j=0;
     strcpy(root,Instr.Instr[i].nemot);
     while(root[j])
       if(root[j]=='.') {
         root[j]=0;
         strcpy(defdes,root+j+1);
       }
       else j++;
     if(dest[0] && !defdes[0])
       continue; //instruction comes with dest and not allowed
     if(defdes[0] && strcmp(defdes,"DEST")) {
       if(strcmp(dest,defdes))
         continue; //dest is not xyzw, instead is fixed
     }

     *InstIndex=i;
     *flavor=0;
     if(!strcmp(root,token)) {
       //the only exception in all instructions
       if(!strcmp(token,"CLIPW"))
        *flavor=5;
       return 1;
     }
     if(Instr.Instr[i].sufix!=0) {
       //flavor 1
       *flavor=1;
       sprintf(root2,"%s%s",root,"I");
       if(!strcmp(root2,token))
         return 1;
       //flavor 2
       *flavor=2;
       sprintf(root2,"%s%s",root,"X");
       if(!strcmp(root2,token))
       return 1;
       *flavor=3;
       sprintf(root2,"%s%s",root,"Y");
       if(!strcmp(root2,token))
         return 1;
       *flavor=4;
       sprintf(root2,"%s%s",root,"Z");
       if(!strcmp(root2,token))
         return 1;
       *flavor=5;
       sprintf(root2,"%s%s",root,"W");
       if(!strcmp(root2,token))
         return 1;
     }
     if(Instr.Instr[i].sufix==2) {
       //flavor 6
       *flavor=6;
       sprintf(root2,"%s%s",root,"Q");
       if(!strcmp(root2,token))
         return 1;
       //flavor 7
       *flavor=7;
       sprintf(root2,"%s%s",root,"A");
       if(!strcmp(root2,token))
         return 1;
       //flavor 8
       *flavor=8;
       sprintf(root2,"%s%s",root,"AI");
       if(!strcmp(root2,token))
         return 1;
       //flavor 9
       *flavor=9;
       sprintf(root2,"%s%s",root,"AQ");
       if(!strcmp(root2,token))
         return 1;
       //flavor 10
       *flavor=10;
       sprintf(root2,"%s%s",root,"AX");
       if(!strcmp(root2,token))
         return 1;
       *flavor=11;
       sprintf(root2,"%s%s",root,"AY");
       if(!strcmp(root2,token))
         return 1;
       *flavor=12;
       sprintf(root2,"%s%s",root,"AZ");
       if(!strcmp(root2,token))
         return 1;
       *flavor=13;
       sprintf(root2,"%s%s",root,"AW");
       if(!strcmp(root2,token))
         return 1;
     }
  }
  *InstIndex=0;
  *flavor=0;
  return 0;
}

int IndexMode(char *a) {
 int i;
 char *Type[]={"VI", "VF", "VIDEST", "VFDEST", "ACC",
 "IMM24", "IMM15", "IMM12", "IMM11", "IMM5", "I",
 "IMM11(VI)", "IMM11(VI)DEST", "(VI)DEST", "(--VI)",
 "(VI++)", "P", "Q", "R", "VI01", "FMM32"};
 for (i=0; i<20; i++)
   if(!strcmp(strupr(a),Type[i])) return i+1;
 return 0;
}

int VIindex(char *a, char *dest)
{
 int i=2,j;
 if(a[0]!='V' || a[1]!='I') return -1;
 while (a[i]=='0' && a[i]) i++;
 if(!a[i]) return 0;
 j=atoi(a+i);
 while (isdigit(a[i++]));
 if(a[i-1]=='.')
   strcpy(dest,a+i);
 else
   strcpy(dest,a+i-1);
 if (j<0 || j>16) return -1;
 return j;
}

int VFindex(char *a, char *dest)
{
 int i=2,j;
 if(a[0]!='V' || a[1]!='F') return -1;
 while (a[i]=='0' && a[i]) i++;
 if(!a[i]) return 0;
 j=atoi(a+i);
 while (isdigit(a[i++]));
 if(a[i-1]=='.')
   strcpy(dest,a+i);
 else
   strcpy(dest,a+i-1);
 if (j<0 || j>32) return -1;
 return j;
}

int SameDest(char *a, char *b)
{
//check a nd b are the same destinations
 int i,j;
 if (!a[0]) return 1; //if no dest specified takes default

 i=0;
 while(a[i]) {
   for(j=0; b[j]; j++)
     if(a[i]==b[j])
       break;
   if(!b[j])
     return 0;
   i++;
 }

 i=0;
 while(b[i]) {
   for(j=0; a[j]; j++)
     if(b[i]==a[j])
       break;
   if(!a[j])
     return 0;
   i++;
 }
 return 1;
}


int GetVal(char *a, long *b)
{
 int i=0;
 long offset;
 char auxi[100], auxi2[100];

 strcpy(auxi,a);
 while(auxi[i]!='+' && auxi[i]!='-' && auxi[i]) i++;
 if(auxi[i]=='+')
   offset=atol(auxi+i+1);
 if(auxi[i]=='-')
   offset=atol(auxi+i);
 if(auxi[i]==0)
   offset=0;
 auxi[i]=0;
 for(i=0; i<VUchip.NSymbols; i++) {
   strcpy(auxi2,VUchip.Labels[i].symb);
   if(!strcmp(auxi,strupr(auxi2))) {
        *b=offset+(long)VUchip.Labels[i].Line;
        return 2;
   }
 }
 for(i=0; i<VUchip.NMemDir; i++) {
   strcpy(auxi2,VUchip.MemDir[i].symb);
   if(!strcmp(auxi,strupr(auxi2))) {
        *b=offset+(long)VUchip.MemDir[i].Line;
        return 2;
   }
 }
 i=0;
 while(auxi[i]=='0') i++;
 if(auxi[i]=='X') { //ex format
   *b= offset+(long) htol(auxi+i+1);
   return 1;
 }
 *b=offset+(long)atol(auxi);
 return 1;
}

int UGetVal(char *a, unsigned long *b, int *md)
{
 int i;
 i=strlen(a);
 *md=0;
 if(a[0]=='(' && a[i-1]==')') {
   *md=1;
   a[i-1]=0;
   strcpy(a,a+1);
 }

 for(i=0; i<VUchip.NSymbols; i++)
   if(!strcmp(a,VUchip.Labels[i].symb)) {
        *b=(unsigned long)VUchip.Labels[i].Line;
        return 2;
   }
 for(i=0; i<VUchip.NMemDir; i++)
   if(!strcmp(a,VUchip.MemDir[i].symb)) {
        *b=(unsigned long)VUchip.MemDir[i].Line;
        return 2;
   }
 i=0;
 while(a[i]=='0') i++;
 if(a[i]=='X') { //ex format
   *b= (unsigned long) htol(a+i+1);
   return 1;
 }
 *b=(unsigned long)atol(a);
 return 1;
}

int FGetVal(char *a, float *b)
{
 char auxi[100];

 strcpy(auxi,a);
 *b=atof(auxi);
 return 1;
}

int SetParam(VUInstruction &inst, int j, int mode, char * token)
{
//check if param is correct and store it in instruction class
//TYPE OF PARAM VI VF VIdest VFdest ACCdest Imm24 Imm15 Imm12 Imm11 Imm5 I
//TYPE OF PARAM Imm11(VI) Imm11(VI)dest (VI)dest (--VI) (VI++) P Q R VI01 Fmm32
 char *flavors[]={"","i","x","y","z","w","q","A","Ai","Aq","Ax","Ay","Az","Aw"};
 int i,k,v,w,NemoMode,md;
 long Imm11, Imm5;
 unsigned long Imm24, Imm15, Imm12;
 float Fmm32;
 char root[100],dest[20];

 strcpy(root,strupr(token));
 i=IndexMode(Instr.Instr[inst.InstIndex[mode]].types[j]);

 inst.Params[mode][j].type=i;
 if(inst.flavor[mode]> 6 && j==0)
   inst.Params[mode][j].type=5; //Acumulator
 if(inst.flavor[mode]==1 && j==2)
   inst.Params[mode][j].type=11; //I register
 if(inst.flavor[mode]==8 && j==2)
   inst.Params[mode][j].type=11; //I register
 if(inst.flavor[mode]==6 && j==2)
   inst.Params[mode][j].type=18; //Q register
 if(inst.flavor[mode]==9 && j==2)
   inst.Params[mode][j].type=18; //Q register

 inst.Params[mode][j].sufix[0]=0;
 w=0;
 strcpy(dest,Instr.Instr[inst.InstIndex[mode]].nemot);
 strrev(dest);
 if(!strncmp(dest,"TSED.",5))
   NemoMode=1; //dest specified in instruction
 else
   NemoMode=0; //dest not specified in instruction
 switch (i) {
   case 1: //VInn
        k=VIindex(root, dest);
        if(k<0) return 0;
        inst.Params[mode][j].index=k;
        break;
   case 2: //VFnn
        k=VFindex(root, dest);
        if(k<0) return 0;
        inst.Params[mode][j].index=k;
        break;
   case 3: //VIdest
        k=VIindex(root, dest);
        if(k<0) return 0;
        if(NemoMode)
          if(!SameDest(dest,inst.dest[mode]))
            return 0;
        inst.Params[mode][j].index=k;
        strcpy(inst.Params[mode][j].sufix,dest);
        break;
   case 4: //VFdest
        k=VFindex(root,dest);
        if(k<0) return 0;
        //check for broadcast cause is differen dest testing
        if(NemoMode) {
          if(j==Instr.Instr[inst.InstIndex[mode]].operands-1) {
            if(inst.flavor[mode]>9)
              if(!SameDest(dest,strupr(flavors[inst.flavor[mode]]+1)))
                return 0;
            if(inst.flavor[mode]>1 && inst.flavor[mode]<6)
              if(!SameDest(dest,strupr(flavors[inst.flavor[mode]])))
                return 0;
          }
          else {
              if(!SameDest(dest,inst.dest[mode])) return 0;
          }
        }
        inst.Params[mode][j].index=k;
        strcpy(inst.Params[mode][j].sufix,dest);
        break;
   case 5: //ACCdest
        if(strncmp(root,"ACC",3)) return 0;
        strcpy(dest,root+3);
        if(NemoMode)
          if(!SameDest(dest,inst.dest[mode]))
            return 0;
        inst.Params[mode][j].type=i;
        strcpy(inst.Params[mode][j].sufix,dest);
        break;
   case 6: //Imm24
        if(!UGetVal(root,&Imm24,&md)) return 0;
        inst.Params[mode][j].udata=Imm24;
        inst.Params[mode][j].memdir=md;
        break;
   case 7: //Imm15
        if(!UGetVal(root,&Imm15,&md)) return 0;
        inst.Params[mode][j].udata=Imm15;
        inst.Params[mode][j].memdir=md;
        break;
   case 8: //Imm12
        if(!UGetVal(root,&Imm12,&md)) return 0;
        inst.Params[mode][j].udata=Imm12;
        inst.Params[mode][j].memdir=md;
        break;
   case 9: //Imm11
        v=GetVal(root,&Imm11);
        if(!v) return 0;
        if(v==2)
          strcpy(inst.Params[mode][j].label,root);
        inst.Params[mode][j].data=Imm11;
        break;
   case 10: //Imm5
        if(!GetVal(root,&Imm5)) return 0;
        inst.Params[mode][j].data=Imm5;
        break;
   case 11: //I
        if(root[0]!='I') return 0;
        break;
   case 12: //Imm11(VI)
        v=0;
        while(root[v]!='(' && root[v]) v++;
        if (!root[v]) return 0;
        root[v]=0;
        w=GetVal(root,&Imm11);
        if(!w) return 0;
        if(w==2)
          strcpy(inst.Params[mode][j].label,root);
        strcpy(root,root+v+1);
        v=0;
        while(root[v]!=')' && root[v]) v++;
        if (!root[v]) return 0;
        root[v]=0;
        k=VIindex(root, dest);
        if(k<0) return 0;
        inst.Params[mode][j].data=Imm11;
        inst.Params[mode][j].index=k;
        break;
   case 13: //Imm11(VI)dest
        v=0;
        while(root[v]!='(' && root[v]) v++;
        if (!root[v]) return 0;
        root[v]=0;
        w=GetVal(root,&Imm11);
        if(!w) return 0;
        if(w==2)
          strcpy(inst.Params[mode][j].label,root);
        strcpy(root,root+v+1);
        v=0;
        while(root[v]!=')' && root[v]) v++;
        if (!root[v]) return 0;
        root[v]=0;
        strcat(root,root+v+1); //cat dest
        k=VIindex(root, dest);
        if(k<0) return 0;
        if(NemoMode)
          if(!SameDest(dest,inst.dest[mode]))
            return 0;
        inst.Params[mode][j].data=Imm11;
        inst.Params[mode][j].index=k;
        strcpy(inst.Params[mode][j].sufix,dest);
        break;
   case 14: //(VI)dest
        if (root[0]!='(') return 0;
        strcpy(root,root+1);
        v=0;
        while(root[v]!=')' && root[v]) v++;
        if (!root[v]) return 0;
        root[v]=0;
        strcat(root,root+v+1); //cat dest
        k=VIindex(root, dest);
        if(NemoMode)
          if(!SameDest(dest,inst.dest[mode]))
            return 0;
        inst.Params[mode][j].index=k;
        strcpy(inst.Params[mode][j].sufix,dest);
        break;
   case 15: //(--VI)
        if (strncmp(root,"(--",3)) return 0;
        strcpy(root,root+3);
        v=0;
        while(root[v]!=')' && root[v]) v++;
        if (!root[v]) return 0;
        root[v]=0;
        k=VIindex(root, dest);
        inst.Params[mode][j].index=k;
        break;
   case 16: //(VI++)
        strrev(root);
        if (strncmp(root,")++",3)) return 0;
        strcpy(root,root+3);
        strrev(root);
        strcpy(root,root+1);
        k=VIindex(root, dest);
        inst.Params[mode][j].index=k;
        strcpy(inst.Params[mode][j].sufix,dest);
        break;
   case 17: //P
        if (strcmp(root,"P")) return 0;
        break;
   case 18: //Q
        if (strcmp(root,"Q")) return 0;
        break;
   case 19: //R
        if (strcmp(root,"R")) return 0;
        break;
   case 20: //VI01
        if (strcmp(root,"VI01")) return 0;
        inst.Params[mode][j].index=1;
        break;
   case 21: //Fmm32
        if (strcmp(root,"FMM32")) return 0;
        if(!FGetVal(root,&Fmm32)) return 0;
        inst.Params[mode][j].fdata=Fmm32;
        break;
 }
 return 1;
}

int ProcessInstruction(char * Line)
{
 //this functions should process upper and lower instruction line
 //first we spect to find the upper instruction
 int i=0,j,k,InstIndex, flavor=0;
 char token[50], dest[50], flg;

 while (Line[i]!=' ' && Line[i]!='\t' && Line[i]!=0) i++;
 if (!Line[i]) return 0; //no separator found
 strncpy(token,Line,i);
 token[i]=0;
 strupr(token);
 if(!IsValidInstruction(token, UPPER, &InstIndex, &flavor,dest, &flg))
  return 0;
 VUchip.program [VUchip.NInstructions].InstIndex[UPPER]=InstIndex;
 strcpy(VUchip.program [VUchip.NInstructions].dest[UPPER],dest);
 VUchip.program [VUchip.NInstructions].flavor[UPPER]=flavor;
 VUchip.program [VUchip.NInstructions].breakpoint=0;
 VUchip.program [VUchip.NInstructions].flg=flg;
 for (j=0; j<Instr.Instr[InstIndex].operands; j++) {
   if(j==Instr.Instr[InstIndex].operands-1) { //last operand
     //first eliminate heading blanks
     while ((Line[i]==' ' || Line[i]=='\t') && Line[i]!=0) i++;
     k=i;
     while (Line[i]!=' ' && Line[i]!='\t' && Line[i]!=0) i++;
     strncpy(token,Line+k,i-k);
     token[i-k]=0;  //parameter grabbed in token
     SetParam(VUchip.program [VUchip.NInstructions],j,UPPER,token);
   }
   else { //intermediate operand, search for a ','
     while ((Line[i]==' ' || Line[i]=='\t') && Line[i]!=0) i++;
     k=i;
     while(Line[i]!=',' && Line[i]) i++;
     strncpy(token,Line+k,i-k);
     token[i-k]=0; //parameter grabbed in token
     SetParam(VUchip.program [VUchip.NInstructions],j,UPPER,token);
     if(Line[i]==',') i++;
   }
 }
 if(!Line[i]) return 0; //sintax error

 //eliminate heading blanks
 while ((Line[i]==' ' || Line[i]=='\t') && Line[i]!=0) i++;
 if(!Line[i]) return 0; //sintax error
 j=i;
 while (Line[i]!=' ' && Line[i]!='\t' && Line[i]!=0) i++;
 strncpy(token,Line+j,i-j);
 token[i-j]=0;
 strupr(token);

 if(!IsValidInstruction(token, LOWER, &InstIndex, &flavor,dest, &flg))
  return 0;
 VUchip.program [VUchip.NInstructions].InstIndex[LOWER]=InstIndex;
 strcpy(VUchip.program [VUchip.NInstructions].dest[LOWER],dest);
 VUchip.program [VUchip.NInstructions].flavor[LOWER]=flavor;
 for (j=0; j<Instr.Instr[InstIndex].operands; j++) {
   if(j==Instr.Instr[InstIndex].operands-1) { //last operand
     //first eliminate heading blanks
     while ((Line[i]==' ' || Line[i]=='\t') && Line[i]!=0) i++;
     k=i;
     while (Line[i]!=' ' && Line[i]!='\t' && Line[i]!=0) i++;
     strncpy(token,Line+k,i-k);
     token[i-k]=0;
     SetParam(VUchip.program [VUchip.NInstructions],j,LOWER,token);
   }
   else { //intermediate operand, search for a ','
     while ((Line[i]==' ' || Line[i]=='\t') && Line[i]!=0) i++;
     k=i;
     while(Line[i]!=',' && Line[i]) i++;
     strncpy(token,Line+k,i-k);
     token[i-k]=0;
     SetParam(VUchip.program [VUchip.NInstructions],j,LOWER,token);
     if(Line[i]==',') i++;
   }
 }
 VUchip.NInstructions++;
 return 1;
}


int MatchSymbol(char *Line)
{
 int i;
 i=strlen(Line);
 if(Line[i-1]!=':')
   return 0;
 Line[i-1]=0;
 for(i=0; i<VUchip.NSymbols; i++)
   if(!strcmp(Line,VUchip.Labels[i].symb)) {
     VUchip.program [VUchip.NInstructions].SymbolIndex=i;
     return 1;
   }
 return 0;
}

int ProcessLine(char *Line)
{
 //we spect to find here a label
 //or a upper - lower pair
 int i;

 i=strlen(Line);
 if(Line[i-1]==':') //is a label
   return MatchSymbol(Line);
 else
   return ProcessInstruction(Line);

}

int ProcessSymbol(char *Line)
{
 //we spect to find here a label
 //or a upper - lower pair
 int i;

 i=strlen(Line);
 if(Line[i-1]!=':') { //it is an instruction
   counter++;
   return 1;
 }
 Line[i-1]=0;
 strcpy(VUchip.Labels[VUchip.NSymbols].symb,Line);
 VUchip.Labels[VUchip.NSymbols].Line=VUchip.NInstructions;
 VUchip.Labels[VUchip.NSymbols].Line=counter;
 VUchip.NSymbols++;
 return 1;
}


int LoadSymbol(char *file)
{
 FILE *In;
 char Line[250];
 int j=0;
 if((In=fopen(file,"r"))==NULL)
   return 0;
 counter=0;
 while(fgets(Line,250,In)) {
   j=0;
   //truncate remarks
   while(Line[j]) {
     if(Line[j]==';')
       Line[j]=0;
     else
       j++;
   }
   strtrim(Line);
   if(Line[0]==';' || Line[0]==0) //comment or empty line
        continue;
   if(!ProcessSymbol(Line)) {
     VUchip.Reset();
     return 0;
   }
 }
 return 1;
}



int LoadCode(char *file, char * error)
{
 FILE *In;
 char Line[250];
 int j=0, g=0;
 VUchip.Reset();
 if(!LoadSymbol(file))
  return 0;
 if((In=fopen(file,"r"))==NULL)
   return 0;
 while(fgets(Line,250,In)) {
   j=0;
   g++;
   //truncate remarks
   while(Line[j]) {
     if(Line[j]==';')
       Line[j]=0;
     else
       j++;
   }
   strtrim(Line);
   if(Line[0]==';' || Line[0]==0) //comment or empty line
        continue;
   if(!ProcessLine(Line)) {
     sprintf(error, "Sintax error in line %d\n\"%s\"",g,Line);
     VUchip.Reset();
     return 0;
   }
 }
 return 1;
}


